/* kernel.c */
// taken from http://ksrenevasan.blogspot.com/2005/10/writing-multiboot-pe-kernels-using.html
#include "kernel.h"

__declspec(naked) void __multiboot_entry__(void)
{
          __asm {
          
          multiboot_header:
                    dd(0x1BADB002)               ; magic
                    dd(1 << 16)                    ; flags
                    dd(-(0x1BADB002 + (1 << 16)))     ; checksum
                    dd(0x00101000)               ; header_addr
                    dd(0x00101000)               ; load_addr
                    dd(0x0010200F)               ; load_end_addr
                    dd(0x0010200F)               ; bss_end_addr
                    dd(0x00101030)               ; entry_addr
                    dd(0x00000000)               ; mode_type
                    dd(0x00000000)               ; width
                    dd(0x00000000)               ; height
                    dd(0x00000000)               ; depth

          kernel_entry:
                    mov     esp,     KERNEL_STACK

                    xor     ecx,     ecx
                    push     ecx
                    popf

                    push     eax
                    push     ebx
                    call     main

                    jmp     $
          }
}

void main(unsigned long magic, unsigned long addr)
{
		  char *message1 = "Hello Simple Kernel World!";
		  char *message2 = "This is the Visual World calling!";
		  char *message3 = "Why does all my assembler crash?";

		  print(message2, 0);
		  print(message1, 80*2);
}

void print(char* message, unsigned long offs)
{
		  __asm
		  {
					mov ebx, offs
					mov edx, message
					mov eax, 0
					mov ah, 0x07

					mov cl, 25

				letter:
					mov al, [edx]
					mov [0xb8000+ebx], eax
					inc ebx
					inc ebx
					inc edx

					dec cl
					jnz letter
		  }
}
